/*****************************************************************************

$Id: eventmachine.h 265 2006-10-05 19:07:45Z blackhedd $

File:     eventmachine.h
Date:     15Apr06

Copyright (C) 2006 by Francis Cianfrocca. All Rights Reserved.
Gmail: garbagecat10

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*****************************************************************************/

#ifndef __EVMA_EventMachine__H_
#define __EVMA_EventMachine__H_

#if __cplusplus
extern "C" {
#endif

	void evma_initialize_library (void(*)(const char*, int, const char*, int));
	void evma_run_machine();
	void evma_release_library();
	const char *evma_install_oneshot_timer (int seconds);
	const char *evma_connect_to_server (const char *server, int port);
	const char *evma_create_tcp_server (const char *address, int port);
	const char *evma_create_unix_domain_server (const char *filename);
	const char *evma_open_datagram_socket (const char *server, int port);
	void evma_start_tls (const char *binding);
	int evma_get_peername (const char *binding, struct sockaddr*);
	int evma_send_data_to_connection (const char *binding, const char *data, int data_length);
	int evma_send_datagram (const char *binding, const char *data, int data_length, const char *address, int port);
	int evma_get_comm_inactivity_timeout (const char *binding, /*out*/int *value);
	int evma_set_comm_inactivity_timeout (const char *binding, /*in,out*/int *value);
	void evma_close_connection (const char *binding, int after_writing);
	void evma_signal_loopbreak();
	void evma_set_timer_quantum (int);
	void evma_stop_machine();

	const char *evma__write_file (const char *filename);

#if __cplusplus
}
#endif


#endif // __EventMachine__H_

