# $Id: factory.rb 90 2006-05-19 04:58:15Z blackhedd $
#
# Homepage::  http://rubyeventmachine.com
# Copyright:: (C) 2006 by Francis Cianfrocca. All Rights Reserved.
# Email:: gmail address: garbagecat10
#
# Available under the GNU Lesser General Public License.
# See the file COPYING in the distribution for full licensing information.
#-------------------------------------------------------------------
# This file is part of Ruby/EventMachine.
#
# Ruby/EventMachine is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or
# (at your option) any later version.
# 
# Ruby/EventMachine is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Ruby/EventMachine; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#-------------------------------------------------------------------
#


module Evma
class ProtocolFactory < Protocol

  #--
  # default implementation raises an exception.
  # we expect subclasses to override this.
  # we can't do anything reasonable here because
  def accept new_object
    # don't bother calling Evma::Reactor.instance, since only Reactor can call accept
    Evma::Container.store Evma::Protocol.new( new_object )
    EventMachine.close_connection new_object, false
  end


end # class ProtocolFactory
end # module Evma

######################################

module Evma
class TcpSocket

  def self.connect server, port, protocol_handler = Evma::Protocol
    Evma::Reactor.instance # ensure initialization
    sig = EventMachine.connect_server server, port
    Evma::Container.store protocol_handler.new( sig )
  end

end
end # module Evma

######################################

module Evma
class TcpServerFactory < Evma::ProtocolFactory

  def initialize server, port, protocol_handler = Evma::Protocol
    Evma::Reactor.instance # ensure initialization
    sig = EventMachine.start_tcp_server server, port
    super sig
    @protocol_handler = protocol_handler
    Evma::Container.store self
  end

  def accept new_obj
    # don't bother calling Evma::Reactor.instance, since only Reactor can call accept
    Evma::Container.store @protocol_handler.new( new_obj )
  end

end
end # module Evma

