# $Id: protocol.rb 90 2006-05-19 04:58:15Z blackhedd $
#
# Homepage::  http://rubyeventmachine.com
# Copyright:: (C) 2006 by Francis Cianfrocca. All Rights Reserved.
# Email:: gmail address: garbagecat10
#
# Available under the GNU Lesser General Public License.
# See the file COPYING in the distribution for full licensing information.
#-------------------------------------------------------------------
# This file is part of Ruby/EventMachine.
#
# Ruby/EventMachine is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or
# (at your option) any later version.
# 
# Ruby/EventMachine is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Ruby/EventMachine; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#-------------------------------------------------------------------
#

module Evma
class Protocol

  attr_reader :signature

  def initialize sig
    @signature = sig
  end

  def unbind
  end

  def close
    Evma::Reactor.instance # ensure initialized
    EventMachine.close_connection signature, false
  end

  def close_after_writing
    Evma::Reactor.instance # ensure initialized
    EventMachine.close_connection signature, true
  end

end # class Protocol
end # module Evma


###########################################

module Evma
class StreamProtocol < Protocol

  def initialize sig
    super
  end

  def send_data data
    Evma::Reactor.instance # ensure initialized
    EventMachine.send_data signature, data, data.length
  end

end # class Protocol
end # module Evma


###########################################

module Evma
class DatagramProtocol < Protocol

  def initialize sig
    super
  end

  def send_message data
    Evma::Reactor.instance # ensure initialized
    raise "unimplemented"
  end

end # class Protocol
end # module Evma


