# $Id: test_eventables.rb 252 2006-09-02 19:23:20Z blackhedd $
#
# Author:: blackhedd (gmail address: garbagecat10).
# Date:: 8 Apr 2006
#
# Copyright (C) 2006 by Francis Cianfrocca. All Rights Reserved.
#
# This program is made available under the terms of the GPL version 2.
#
# See EventMachine and EventMachine::Connection for documentation and
# usage examples.
#
#----------------------------------------------------------------------------
#
# Copyright (C) 2006 by Francis Cianfrocca. All Rights Reserved.
#
# Gmail: garbagecat10
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#---------------------------------------------------------------------------
#
#

$:.unshift "../lib"
require 'eventmachine'

require 'test/unit/testsuite'
require 'test/unit/ui/console/testrunner'


class TestEventables < Test::Unit::TestCase

  class EvTest
    include EventMachine::Eventable
  end

  def setup
  end

  def teardown
  end

  def test_a
    n = 0
    tester = EvTest.new
    tester.listen_event( :fire1 ) {|arg|
      n = 1 if arg == "$"
      EventMachine.stop
    }
    tester.post_event( :fire1, "$" )
    
    EventMachine.run {
      EventMachine::add_timer(1) {EventMachine.stop}
    }

    assert n == 1
  end

end


#--------------------------------------

if __FILE__ == $0
  runner = Test::Unit::UI::Console::TestRunner
  suite = Test::Unit::TestSuite.new("name")
  ObjectSpace.each_object(Class) do |testcase|
    suite << testcase.suite if testcase < Test::Unit::TestCase
  end
  runner.run(suite)
end

